"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.json5Schema = void 0;
const codemirror_json5_1 = require("codemirror-json5");
const view_1 = require("@codemirror/view");
const completion_js_1 = require("./completion.js");
const validation_js_1 = require("./validation.js");
const hover_js_1 = require("./hover.js");
const lint_1 = require("@codemirror/lint");
const json_validation_js_1 = require("../json-validation.js");
const state_js_1 = require("../state.js");
/**
 * Full featured cm6 extension for json5, including `codemirror-json5`
 * @group Bundled Codemirror Extensions
 */
function json5Schema(schema) {
    return [
        (0, codemirror_json5_1.json5)(),
        (0, lint_1.linter)((0, codemirror_json5_1.json5ParseLinter)()),
        (0, lint_1.linter)((0, validation_js_1.json5SchemaLinter)(), {
            needsRefresh: json_validation_js_1.handleRefresh,
        }),
        codemirror_json5_1.json5Language.data.of({
            autocomplete: (0, completion_js_1.json5Completion)(),
        }),
        (0, view_1.hoverTooltip)((0, hover_js_1.json5SchemaHover)()),
        (0, state_js_1.stateExtensions)(schema),
    ];
}
exports.json5Schema = json5Schema;
