"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.json5SchemaLinter = void 0;
const json_validation_js_1 = require("../json-validation.js");
const parseJSON5Document_js_1 = require("../utils/parseJSON5Document.js");
const constants_js_1 = require("../constants.js");
/**
 * Instantiates a JSONValidation instance with the JSON5 mode
 * @group Codemirror Extensions
 */
function json5SchemaLinter(options) {
    const validation = new json_validation_js_1.JSONValidation(Object.assign({ jsonParser: parseJSON5Document_js_1.parseJSON5DocumentState, mode: constants_js_1.MODES.JSON5 }, options));
    return (view) => {
        return validation.doValidation(view);
    };
}
exports.json5SchemaLinter = json5SchemaLinter;
