"use strict";
/**
 * Mimics the behavior of `json-source-map`'s `parseJSONDocument` function using codemirror EditorState... for YAML
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseYAMLDocumentState = void 0;
const yaml_1 = __importDefault(require("yaml"));
const jsonPointers_js_1 = require("./jsonPointers.js");
const constants_js_1 = require("../constants.js");
/**
 * Return parsed data and YAML pointers for a given codemirror EditorState
 * @group Utilities
 */
function parseYAMLDocumentState(state) {
    let data = null;
    try {
        data = yaml_1.default.parse(state.doc.toString());
        // return pointers regardless of whether YAML.parse succeeds
    }
    catch (_a) { }
    const pointers = (0, jsonPointers_js_1.getJsonPointers)(state, constants_js_1.MODES.YAML);
    return { data, pointers };
}
exports.parseYAMLDocumentState = parseYAMLDocumentState;
