"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.yamlSchema = void 0;
const lang_yaml_1 = require("@codemirror/lang-yaml");
const view_1 = require("@codemirror/view");
const json_validation_js_1 = require("../json-validation.js");
const state_js_1 = require("../state.js");
const lint_1 = require("@codemirror/lint");
const validation_js_1 = require("./validation.js");
const completion_js_1 = require("./completion.js");
const hover_js_1 = require("./hover.js");
/**
 * Full featured cm6 extension for json, including `@codemirror/lang-json`
 * @group Bundled Codemirror Extensions
 */
function yamlSchema(schema) {
    return [
        (0, lang_yaml_1.yaml)(),
        (0, lint_1.linter)((0, validation_js_1.yamlSchemaLinter)(), {
            needsRefresh: json_validation_js_1.handleRefresh,
        }),
        lang_yaml_1.yamlLanguage.data.of({
            autocomplete: (0, completion_js_1.yamlCompletion)(),
        }),
        (0, view_1.hoverTooltip)((0, hover_js_1.yamlSchemaHover)()),
        (0, state_js_1.stateExtensions)(schema),
    ];
}
exports.yamlSchema = yamlSchema;
