"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.yamlSchemaHover = void 0;
const json_hover_js_1 = require("../json-hover.js");
const yaml_1 = __importDefault(require("yaml"));
const constants_js_1 = require("../constants.js");
/**
 * Instantiates a JSONHover instance with the YAML mode
 * @group Codemirror Extensions
 */
function yamlSchemaHover(options) {
    const hover = new json_hover_js_1.JSONHover(Object.assign(Object.assign({}, options), { parser: yaml_1.default.parse, mode: constants_js_1.MODES.YAML }));
    return async function jsonDoHover(view, pos, side) {
        return hover.doHover(view, pos, side);
    };
}
exports.yamlSchemaHover = yamlSchemaHover;
