"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.yamlSchemaLinter = void 0;
const json_validation_js_1 = require("../json-validation.js");
const parse_yaml_document_js_1 = require("../utils/parse-yaml-document.js");
const constants_js_1 = require("../constants.js");
/**
 * Instantiates a JSONValidation instance with the YAML mode
 * @group Codemirror Extensions
 */
function yamlSchemaLinter(options) {
    const validation = new json_validation_js_1.JSONValidation(Object.assign({ jsonParser: parse_yaml_document_js_1.parseYAMLDocumentState, mode: constants_js_1.MODES.YAML }, options));
    return (view) => {
        return validation.doValidation(view);
    };
}
exports.yamlSchemaLinter = yamlSchemaLinter;
