import { JSONValidation, } from "../json-validation.js";
import { parseJSON5DocumentState } from "../utils/parseJSON5Document.js";
import { MODES } from "../constants.js";
/**
 * Instantiates a JSONValidation instance with the JSON5 mode
 * @group Codemirror Extensions
 */
export function json5SchemaLinter(options) {
    const validation = new JSONValidation(Object.assign({ jsonParser: parseJSON5DocumentState, mode: MODES.JSON5 }, options));
    return (view) => {
        return validation.doValidation(view);
    };
}
