import { JSONValidation, } from "../json-validation.js";
import { parseYAMLDocumentState } from "../utils/parse-yaml-document.js";
import { MODES } from "../constants.js";
/**
 * Instantiates a JSONValidation instance with the YAML mode
 * @group Codemirror Extensions
 */
export function yamlSchemaLinter(options) {
    const validation = new JSONValidation(Object.assign({ jsonParser: parseYAMLDocumentState, mode: MODES.YAML }, options));
    return (view) => {
        return validation.doValidation(view);
    };
}
